



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>可拖拽的ListView</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">可拖拽的ListView</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 07:50:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天研究了一下可拖拽的ListView ，当ListView的数据不能充满整个模拟器的时候，系统自带的listview上拖下拽都不好使，显得很单调，</p>
<p>为了实现上拖下拽时也能实现滚动的效果，这时候就需要自定义ListView ，继承系统的ListView。</p>
<p><em>下面贴上自定义的ListView 。</em></p>
<div>
<pre class="prettyprint linenums">package com.xiang.widget;

import android.content.Context;<br />
import android.util.AttributeSet;<br />
import android.view.MotionEvent;<br />
import android.widget.ListView;

public class DenifyMyListView extends ListView implements Runnable {<br />
private float mFirstDownY=0f;<br />
private int mDistance=0;<br />
private int mStep=0;<br />
private boolean mpostive=false;<br />
    public DenifyMyListView(Context context, AttributeSet attrs, int defStyle) {<br />
        super(context, attrs, defStyle);

    }<br />
    public DenifyMyListView(Context context, AttributeSet attrs) {<br />
        super(context, attrs);

    }<br />
    public DenifyMyListView(Context context) {<br />
        super(context);

    }<br />
    @Override<br />
    public boolean onTouchEvent(MotionEvent ev) {<br />
        // TODO Auto-generated method stub<br />
        switch (ev.getAction()) {<br />
        case MotionEvent.ACTION_DOWN:<br />
            if(mFirstDownY == 0f &amp;&amp; mDistance == 0)<br />
            {<br />
                mFirstDownY=ev.getY();<br />
                return true;//将事件消耗掉<br />
            }

            break;<br />
        case MotionEvent.ACTION_CANCEL:

            break;<br />
        case MotionEvent.ACTION_UP:<br />
            if(mDistance!=0)<br />
            {<br />
                mStep=1;<br />
                mpostive = ( mDistance &gt; 0);<br />
                this.post(this);<br />
                return true;<br />
            }<br />
            mDistance=0;<br />
            mFirstDownY=0;<br />
            break;

        case MotionEvent.ACTION_MOVE:<br />
            /*<br />
             * 若 第一次按下的Y坐标不为0,并且移动时产生不为0的距离，就产生滑动距离一半的空白ListView,<br />
             * 显示到页面上，若按下坐标为0即相当于没有按下，没有按下滑动自然不会产生。距离还是初始值0<br />
             */<br />
            if(mFirstDownY != 0f)<br />
            {<br />
                mDistance=(int) (mFirstDownY-ev.getY());<br />
                 if ((mDistance &lt; 0 &amp;&amp; getFirstVisiblePosition() == 0 &amp;&amp; getChildAt(0).getTop() == 0)<br />
                         || (mDistance &gt; 0 &amp;&amp; getLastVisiblePosition() == getCount() - 1))<br />
                 {<br />
                     mDistance /= 2;<br />
                     scrollTo(0, mDistance);<br />
                     return true;//同样的，消耗掉这一触摸事件<br />
                 }<br />
            }<br />
            mDistance=0;<br />
            break;<br />
        default:<br />
            break;<br />
        }<br />
        return super.onTouchEvent(ev);<br />
    }<br />
    @Override<br />
    public void run() {<br />
        mDistance += ( mDistance &gt; 0 ? -mStep : mStep);<br />
        scrollTo(0, mDistance);<br />
        if((mDistance &gt;=0 &amp;&amp; !mpostive)||( mpostive &amp;&amp; mDistance &lt;= 0))<br />
        {<br />
            scrollTo(0, 0);<br />
            mDistance=0;<br />
            mFirstDownY=0;<br />
            return;<br />
        }<br />
        mStep += 1;<br />
        this.postDelayed(this, 10);<br />
    }

}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxyjg09.html">C&num;&comma;java&comma;C&plus;&plus; 等变量命名规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qngvgk8.html">异步请求Ajax</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e6o7jq.html">使用windows的远程桌面连接连接Ubuntu</a>
		</li>
						<li><a href="https://www.batexi.com/a/390050o9.html">mark元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj10r79.html">（iOS）viewController背景透明化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjr7ly8.html">ELK-初识Elasticsearch</a>
		</li>
						<li><a href="https://www.batexi.com/a/96prnon8.html">解决Ajax请求时无法重定向的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv4kw38.html">Win7 VS2015 NASM汇编语言环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvkdp38.html">添加dubbo&period;xsd的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2okjj9.html">codeforces724G Xor-matic Number of the Graph</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r65768.html">MyEclipse 黑色主题 jsp 页面 js背景色修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gop00q.html">分布式ID设计方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wex7nq.html">js 对象创建设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o175plq.html">2018&period;12&period;31 NOIP训练 偶数个5（简单数论）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvowj2q.html">vi命令文件编辑</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p6jpnq.html">VS开发环境美化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4wz41q.html">leetcode第一刷&lowbar;Jump Game II</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp64ve9.html">MongoDB 简介及安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77zd1jq.html">C&num;事件订阅及触发例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pl0dmq.html">C&num; 实现WinForm窗口最小化到系统托盘代码</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8k55m58.html">安装idea开发工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7ngmg9.html">select下拉框插件（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jplxe9.html">ElasticSearch 5&period;0&period;1 java API操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2037o9.html">在VC&plus;&plus;6&period;0开发中实现全屏显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7n2j19.html">js判断是手机还是电脑访问网站</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdog1j8.html">ERROR 2002 &lpar;HY000&rpar;&colon; Can&amp;&num;39&semi;t connect to local MySQL server through socket &amp;&num;39&semi;&sol;var&sol;lib&sol;mysql&sol;mysql&period;sock&amp;&num;39&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw04ll9.html">maven添加本地jar包</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7n00j9.html">如何让一个json文件显示在表格里</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxe4x08.html">定时器springMVC</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql52j08.html">自定义BadgeView</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
